// Description: FreeOTFE Hash Device Driver API
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.FreeOTFE.org/
//
// -----------------------------------------------------------------------------
//


#ifndef _FreeOTFE4PDAHashAPI_H
#define _FreeOTFE4PDAHashAPI_H   1

#include "FreeOTFEHashAPICommon.h"

// Required for definition of ULONG
#include <windef.h>

// Following is required for the "_T" macro
/// #include <tchar.h>

#ifdef WINCE
#include <objbase.h>
#endif
#include <initguid.h>  // Required for DEFINE_GUID and other GUID defintions


// =========================================================================
// Exported functions

#define DLLEXPORT_HASH_IDENTIFYDRIVER  TEXT("HashIdentifyDriver")
typedef DWORD (* PHashDLLFnIdentifyDriver)(
                                 DIOC_HASH_IDENTIFYDRIVER*
                                );
DWORD
HashIdentifyDriver(
    DIOC_HASH_IDENTIFYDRIVER* Buffer
);


#define DLLEXPORT_HASH_IDENTIFYSUPPORTED TEXT("HashIdentifySupported")
typedef DWORD (* PHashDLLFnIdentifySupported)(
                                 DWORD,
                                 DIOC_HASH_IDENTIFYSUPPORTED*
                                );
DWORD
HashIdentifySupported(
    DWORD BufferSize,  // In bytes
    DIOC_HASH_IDENTIFYSUPPORTED* Buffer
);


#define DLLEXPORT_HASH_GETHASHDETAILS TEXT("HashGetHashDetails")
typedef DWORD (* PHashDLLFnGetHashDetails)(
                                 GUID*,
                                 HASH*
                                );
DWORD
HashGetHashDetails(
    IN     GUID* HashGUID,
    IN OUT HASH* HashDetails
);


#define DLLEXPORT_HASH_HASH TEXT("HashHash")
typedef DWORD (* PHashDLLFnHash)(
                          GUID*,
                          unsigned int,
                          unsigned char*,
                          unsigned int*, 
                          unsigned char*
                         );
DWORD
HashHash(
    GUID* HashGUID,
    unsigned int BufferSizeIn,
    unsigned char* BufferIn,
    unsigned int* ptrBufferSizeOut,
    unsigned char* BufferOut
);


// =========================================================================
// =========================================================================

#endif

